local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Upgrade1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Upgrade2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Upgrade1.fbx/Materials/Material.Thatch.Edge", "MATERIAL_UPGRADE_THATCHEDGE")
mod:overrideAsset({
    Id = "MATERIAL_UPGRADE_THATCHEDGE",
    HasAlphaTest = true,
})



-- Part Type -------------------------------------------------------------------------------------
mod:registerEnumValue("BUILDING_PART_TYPE", "UPGRADE")



-- Building Function: Double Production --------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION",
    Id = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_WORKPLACE_RECIPE",
            ProductionMultiplier = 2, -- although a float, this only works with integers as of Jan 2022
        },
    },
})



-- Building Function: Double Production --------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION",
    Id = "BUILDING_FUNCTION_UPGRADE_FODDER",
    Name = "BUILDING_PART_UPGRADE_FODDER_NAME",
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_WORKPLACE_RECIPE",
            ProductionMultiplier = 2, -- although a float, this only works with integers as of Jan 2022
        },
    },
})


-- Common Costs --------------------------------------------------------------------------------------
UpgradeCostTools = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_PLANTS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

UpgradeCostField = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_PLANTS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 10 },
            { Resource = "WOOD", Quantity = 5 },
        },
    },
}

UpgradeCostFodder = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_ANIMALS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "STONE", Quantity = 10 },
            { Resource = "TOOL", Quantity = 10 },
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "PLANK", Quantity = 10 },
        },
    },
}

UpgradeCostHousing = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_ANIMALS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 5 },
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "PLANK", Quantity = 10 },
        },
    },
}

UpgradeCostMethods = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_ALCHEMY", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

UpgradeCostMachinery = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_MATHEMATICS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 50 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 25 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
    },
}

UpgradeCostNets = {
    DataType = "BUILDING_PART_COST",
    BuildRightTaxes = {
        { Resource = "RESOURCE_LEARNING_ANIMALS", Quantity = 25 },
        { Resource = "GOLD_COINS", Quantity = 30 },
    },
    UpkeepCost = {
        { Resource = "GOLD_COINS", Quantity = 15 }
    },
    ResourceNeededList = {
        {
            { Resource = "TOOL", Quantity = 10 },
            { Resource = "WOOD", Quantity = 4 },
        },
    },
}
