local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Cheesemaker.Part", "PREFAB_UPGRADE_CHEESE_MAKER" )

-- Grounding
for i = 5, 9 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Cheesemaker.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_CHEESE_MAKER_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_CHEESE_MAKER" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "POT_MILK_PART", OptionalAttachNodeString = "Attach_Minor.005" }, -- from Fantasy Decorations
			{ BuildingPart = "POT_CLOSED_PART", OptionalAttachNodeString = "Attach_Minor.006" }, -- from Fantasy Decorations
			{ BuildingPart = "POT_VASE_CLOSED_PART", OptionalAttachNodeString = "Attach_Minor.007" }, -- from Fantasy Decorations
			{ BuildingPart = "POT_MILK_PART", OptionalAttachNodeString = "Attach_Minor.008" }, -- from Fantasy Decorations
			{ BuildingPart = "POT_VASE_CLOSED_PART", OptionalAttachNodeString = "Attach_Minor.009" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_CHEESE_MAKER",
    Name = "BUILDING_PART_UPGRADE_METHODS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_CHEESE_MAKER_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 1.2, {0, 0}, 8 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMethods,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_CHEESE_MAKER",
    Name = "CHEESE_MAKER",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_CHEESE_MAKER",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_CHEESE_MAKER",
            },
        },
    },
})

if foundation.isModLoaded("f6361b64-05d3-4ab5-a2db-b3b60dc4d307") then

    mod:overrideAsset({
        Id = "BUILDING_LIVESTOCKFARM_CREAMERY",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_CHEESE_MAKER",
                },
            },
        },
    })

end -- Livestock mod
