local mod = ...



-- Upgrade: Tools -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/Orchard.Tools.Part", "PREFAB_UPGRADE_ORCHARD_TOOLS" )

-- Grounding
for i = 10, 11 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/Orchard.Tools.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_ORCHARD_TOOLS_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_ORCHARD_TOOLS" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "TOOLS_BARREL_FARM_PART", OptionalAttachNodeString = "Attach_Minor.010" }, -- from Fantasy Decorations
			{ BuildingPart = "TOOLS_RACK_FARM_PART", OptionalAttachNodeString = "Attach_Minor.011" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_ORCHARD_TOOLS",
    Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_ORCHARD_TOOLS_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {4.0, 2.25}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostTools,
})



-- Add to Building ----------------------------------------------------------------------------
mod:overrideAsset({
    Id = "BUILDING_ORCHARD",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_ORCHARD_TOOLS",
            },
        },
    },
})
